<?php

namespace STM\DB\Query;

use STM\DB\SQL\SelectQuery;
use STM\DB\SQL\Condition;
use \Exception;

/**
 * Test class for QueryFactory.
 * Generated by PHPUnit on 2011-09-02 at 16:44:58.
 * @group database
 */
class QueryFactoryTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;

    protected function setUp() {
        $this->bad_values = array(null, true, array(), new Exception());
    }

    protected function tearDown() {
        
    }

    public function testSelect_all() {
        foreach ($this->bad_values as $value) {
            // table must be string
            $select = QueryFactory::selectAll($value);
            $this->assertTrue($select instanceof SelectQuery);
            $this->assertFalse($select->isValid());

            // table must be string and where Condition
            $select = QueryFactory::selectAll($value, $value);
            $this->assertTrue($select instanceof SelectQuery);
            $this->assertFalse($select->isValid());

            // table must be string, where Condition and order by string
            $select = QueryFactory::selectAll($value, $value, $value);
            $this->assertTrue($select instanceof SelectQuery);
            $this->assertFalse($select->isValid());

            $select = QueryFactory::selectAll('table', $value, $value);
            // where only if valid Condition
            $this->assertFalse(strpos($select->__toString(), "WHERE"));
            // order by only if non empty string
            $this->assertFalse(strpos($select->__toString(), "ORDER BY"));
        }

        $select = QueryFactory::selectAll('table', new Condition('id = 5'), 'id desc');
        $this->assertTrue($select->isValid());
        $this->assertTrue(is_int(strpos($select->__toString(), "WHERE")));
        $this->assertTrue(is_int(strpos($select->__toString(), "ORDER BY")));
    }

    public function testSelect_by_attribute() {
        foreach ($this->bad_values as $value) {
            // attribute must be string
            $this->assertFalse(QueryFactory::selectByAttribute($value, $value, $value));
            $this->assertFalse(QueryFactory::selectByAttribute($value, $value, $value, $value));
            $this->assertFalse(QueryFactory::selectByAttribute('table', $value, '5'));
            $this->assertFalse(QueryFactory::selectByAttribute('table', $value, '5'));
            // value must be scalar
            $this->assertFalse(QueryFactory::selectByAttribute('table', 'id', array()));

            // table can be everything, but if table is not string, then select is not valid
            $select = QueryFactory::selectByAttribute($value, 'id', 5);
            $this->assertTrue($select instanceof SelectQuery);
            $this->assertFalse($select->isValid());
        }
        // non empty strings
        $this->assertFalse(QueryFactory::selectByAttribute('', '', ''));

        $select = QueryFactory::selectByAttribute('table', 'name', '%s%', 'like');
        $this->assertTrue($select->isValid());
        $this->assertTrue(is_int(strpos($select->__toString(), "like")));
        $this->assertTrue(is_int(strpos($select->__toString(), "name")));
    }

    public function testSelect_count() {
        $select = QueryFactory::selectCount('table', new Condition('id < 10'));
        $this->assertTrue($select->isValid());
        $this->assertTrue(is_int(strpos($select->__toString(), "WHERE")));
    }

}

?>
